"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const Drawer_1 = __importDefault(require("../Drawer"));
const Colors_1 = __importDefault(require("../Colors"));
const Button_1 = __importDefault(require("../Button"));
const Icons_1 = __importDefault(require("../Icons"));
const style_1 = __importDefault(require("./style"));
const reducer_1 = __importDefault(require("../Fn/reducer"));
let citySelectView = undefined;
const CitySelectView = ({ title = '配送至', currentData, onSumbit, }) => {
    const useDrawer = (0, react_1.useRef)();
    const initState = {
        cTab: 'prov',
        provList: [
            { name: '北京市', code: '10001' },
            { name: '上海市', code: '10002' },
            { name: '安徽省', code: '10003' },
        ],
        cityList: [
            { name: '合肥', code: '10011' },
            { name: '安庆', code: '10012' },
        ],
        distList: [
            { name: '宿松', code: '101011' },
            { name: '太湖', code: '102012' },
        ],
    };
    const [state, setState] = (0, reducer_1.default)(Object.assign({}, initState));
    const [area, setArea] = (0, react_1.useState)({
        prov: (currentData === null || currentData === void 0 ? void 0 : currentData.prov) || '',
        provCode: (currentData === null || currentData === void 0 ? void 0 : currentData.provCode) || '',
        city: (currentData === null || currentData === void 0 ? void 0 : currentData.city) || '',
        cityCode: (currentData === null || currentData === void 0 ? void 0 : currentData.cityCode) || '',
        dist: (currentData === null || currentData === void 0 ? void 0 : currentData.dist) || '',
        distCode: (currentData === null || currentData === void 0 ? void 0 : currentData.distCode) || '',
    });
    (0, react_1.useLayoutEffect)(() => {
        var _a;
        (_a = useDrawer === null || useDrawer === void 0 ? void 0 : useDrawer.current) === null || _a === void 0 ? void 0 : _a.show();
    }, []);
    const _onClose = () => {
        citySelectView === null || citySelectView === void 0 ? void 0 : citySelectView.destroy();
        citySelectView = undefined;
    };
    const _onSubmit = (res) => {
        var _a;
        onSumbit === null || onSumbit === void 0 ? void 0 : onSumbit(res);
        (_a = useDrawer === null || useDrawer === void 0 ? void 0 : useDrawer.current) === null || _a === void 0 ? void 0 : _a.hide();
    };
    const _onTab = (type) => {
        if (type === 'prov') {
            setArea({
                prov: area.prov,
                provCode: area.provCode,
            });
        }
        else if (type === 'city') {
            setArea(Object.assign(Object.assign({}, area), { dist: '', distCode: '' }));
        }
        setState({ cTab: type });
    };
    const _onSelect = (item, k) => {
        switch (state.cTab) {
            case 'prov':
                setState({ cTab: 'city' });
                setArea({
                    prov: item.name,
                    provCode: item.code,
                });
                break;
            case 'city':
                setState({ cTab: 'dist' });
                setArea({
                    prov: area.prov,
                    provCode: area.provCode,
                    city: item.name,
                    cityCode: item.code,
                });
                break;
            case 'dist':
                setArea(Object.assign(Object.assign({}, area), { dist: item.name, distCode: item.code }));
                _onSubmit(area);
                break;
        }
    };
    const renderList = () => {
        let datas = [];
        switch (state.cTab) {
            case 'prov':
                datas = state.provList;
                break;
            case 'city':
                datas = state.cityList;
                break;
            case 'dist':
                datas = state.distList;
                break;
        }
        return datas.map((v, k) => {
            let style = null;
            if (v.code === area.provCode || v.code === area.cityCode || v.code === area.distCode) {
                style = style_1.default.liActive;
            }
            return (react_1.default.createElement(Button_1.default, { styleContainer: style_1.default.li, key: `area_${v.code}`, onPress: () => {
                    _onSelect(v, k);
                } },
                react_1.default.createElement(react_native_1.Text, { style: style }, v.name),
                style && react_1.default.createElement(Icons_1.default, { name: 'check', color: Colors_1.default.MainColor })));
        });
    };
    const renderTab = () => {
        return (react_1.default.createElement(react_native_1.View, { style: style_1.default.tabs },
            react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'prov' ? style_1.default.tabc : {}], onPress: () => {
                    _onTab('prov');
                } },
                react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'prov' ? style_1.default.tabt : {}] }, area.provCode ? area.prov : '请选择')),
            react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'city' ? style_1.default.tabc : {}], onPress: () => {
                    _onTab('city');
                } }, area.cityCode ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'city' ? style_1.default.tabt : {}] }, area.city)) : (area.provCode ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'city' ? style_1.default.tabt : {}] }, "\u8BF7\u9009\u62E9")) : null)),
            react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'dist' ? style_1.default.tabc : {}], onPress: () => {
                    _onTab('dist');
                } }, area.distCode ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'dist' ? style_1.default.tabt : {}] }, area.dist)) : (area.provCode && area.cityCode ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'dist' ? style_1.default.tabt : {}] }, "\u8BF7\u9009\u62E9")) : null))));
    };
    return (react_1.default.createElement(Drawer_1.default, { styleContainer: style_1.default.container, cRef: useDrawer, title: title, scrollView: false, onClose: _onClose },
        renderTab(),
        react_1.default.createElement(react_native_1.ScrollView, { style: { paddingVertical: 10 } }, renderList())));
};
const CitySelect = (_a) => {
    var props = __rest(_a, []);
    citySelectView === null || citySelectView === void 0 ? void 0 : citySelectView.destroy();
    citySelectView = new react_native_root_siblings_1.default(react_1.default.createElement(CitySelectView, Object.assign({}, props)));
};
exports.default = CitySelect;
