"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
;
const Mask = ({ cRef, duration = 600, }) => {
    const [show, setShow] = (0, react_1.useState)(false);
    const fadeAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    (0, react_1.useImperativeHandle)(cRef, () => ({
        show: () => {
            setShow(true);
        },
        hide: () => {
            _onHide();
        }
    }));
    (0, react_1.useEffect)(() => {
        if (!show)
            return;
        fadeIn();
    }, [show]);
    const _onHide = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
        setTimeout(() => {
            setShow(false);
        }, duration - 10);
    };
    const fadeIn = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 1,
            duration,
            useNativeDriver: true
        }).start();
    };
    const renderView = () => {
        if (!show)
            return null;
        return (react_1.default.createElement(react_native_1.Animated.View, { style: [
                style_1.default.container,
                { opacity: fadeAnim }
            ] }));
    };
    return renderView();
};
exports.default = Mask;
